<?php
/**
 * @file
 */


class SlateModel {

  protected $plugin;
  protected $data;

  public static function factory($plugin, $data) {
    if (class_exists($plugin['handler']['class']) && is_subclass_of($plugin['handler']['class'], __CLASS__)) {
      return new $plugin['handler']['class']($plugin, $data);
    }
    else {
      return new SlateModelBasic($plugin, $data);
    }
  }

  public function __construct($plugin, $data) {
    $this->plugin = $plugin;
    $this->data = $data;
  }

}

class SlateModelBasic extends SlateModel {

  public function __call($name, $arguments) {
    return call_user_func_array(array($this->data, $name), $arguments);
  }

  public function __get($name) {
    return $this->data->{$name};
  }

  public function __isset($name) {
    return isset($this->data->{$name});
  }

}
