<?php
/**
 * @file
 */


$plugin = array(
  'title' => t('Slate'),
  'defaults' => array(
    'slate' => '',
  ),
);


/**
 *
 */
function slate_slate_content_type_content_type($subtype) {
  $types = slate_slate_content_type_content_types();
  if (isset($types[$subtype])) {
    return $types[$subtype];
  }
}

/**
 *
 */
function slate_slate_content_type_content_types() {
  $types = array();

  foreach (slate_get_slates() as $slate => $slate_info) {
    $plugin = array(
      'title' => $slate_info['name'],
      'category' => t('Slate'),
      'required context' => array(),
    );

    foreach ($slate_info['models'] as $model => $model_type) {
      $plugin['required context'][] = new ctools_context_required($model, $model_type);
    }

    $types['slate:' . $slate] = $plugin;
  }

  return $types;
}

/**
 *
 */
function slate_slate_content_type_render($subtype, $conf, $panel_args, $context) {
  if (empty($context)) {
    return FALSE;
  }

  list(, $slate) = explode(':', $subtype);

  $slate_info = slate_get_slate($slate);

  $models = array();

  foreach ($slate_info['models'] as $model => $model_type) {
    $models[$model] = array_shift($context)->data;
  }

  $block = new stdClass();
  $block->module = 'slate';
  $block->title = $slate_info['name'];
  $block->content = slate_render($slate, $models);

  return $block;
}
