<?php
/**
 * @file
 */


class SlateModelEntity extends SlateModelBasic {

  protected $fields = array();

  public function __construct($plugin, $data) {
    parent::__construct($plugin, entity_metadata_wrapper($plugin['entity_type'], $data));
  }

  public function __get($name) {
    if (!isset($this->fields[$name])) {
      if ($this->data->{$name} instanceof EntityStructureWrapper) {
        $this->fields[$name] = new SlateModelEntityStructure($this->data->{$name});
      }
      else {
        $this->fields[$name] = new SlateModelEntityValue($this->data->{$name});
      }
    }

    return $this->fields[$name];
  }

}

class SlateModelEntityStructure {

  protected $data;

  protected $fields = array();

  public function __construct($data) {
    $this->data = $data;
  }

  public function __call($name, $arguments) {
    return call_user_func_array(array($this->data, $name), $arguments);
  }

  public function __get($name) {
    if (!isset($this->fields[$name])) {
      if ($this->data->{$name} instanceof EntityStructureWrapper) {
        $this->fields[$name] = new SlateModelEntityStructure($this->data->{$name});
      }
      else if ($this->data->{$name} instanceof EntityValueWrapper) {
        $this->fields[$name] = new SlateModelEntityValue($this->data->{$name});
      }
      else {
        return $this->data->{$name};
      }
    }

    return $this->fields[$name];
  }

  public function __isset($name) {
    return isset($this->data->{$name});
  }

}

class SlateModelEntityValue {

  protected $data;

  public function __construct($data) {
    $this->data = $data;
  }

  public function __call($name, $arguments) {
    return call_user_func_array(array($this->data, $name), $arguments);
  }

  public function __get($name) {
    return call_user_func_array(array($this->data, $name), array());
  }

  public function __isset($name) {
    return method_exists($this->data, $name);
  }

  public function __toString() {
    return $this->data->value();
  }

}
